Name:        pcre2
Version:     10.39
Release:     9
Summary:     Perl Compatible Regular Expressions
License:     BSD
URL:         http://www.pcre.org/
Source0:     https://github.com/PCRE2Project/pcre2/releases/download/%{name}-%{version}/%{name}-%{version}.tar.bz2

# Do no set RPATH if libdir is not /usr/lib
Patch6000:     backport-pcre2-10.10-Fix-multilib.patch
Patch6001:     backport-CVE-2022-1586-1.patch
Patch6002:     backport-CVE-2022-1586-2.patch
Patch6003:     backport-CVE-2022-1587.patch
Patch6004:     backport-pcre2grep-correctly-handle-multiple-passes-35.patch
Patch6005:     backport-jit-avoid-integer-wraparound-in-stack-size-definitio.patch
Patch6006:     backport-Revert-an-unintended-change-in-JIT-repeat-detection.patch
Patch6007:     backport-match-avoid-crash-if-subject-NULL-and-PCRE2_ZERO_TER.patch
Patch6008:     backport-jit-use-correct-type-when-checking-for-max-value-73.patch
Patch6009:     backport-Fix-recursion-issue-in-JIT.patch
Patch6010:     backport-doc-avoid-nonexistent-PCRE2_ERROR_MEMORY-error-107.patch
Patch6011:     backport-Update-HTML-docs.patch
Patch6012:     backport-Fixed-race-condition-that-occurs-when-initializing-t.patch
Patch6013:     backport-Change-length-variables-in-pcre2grep-from-int-to-siz.patch
Patch6014:     backport-Add-an-ifdef-to-avoid-the-need-even-to-link-with-pcr.patch
Patch6015:     backport-Fixed-an-issue-in-the-backtracking-optimization-of-c.patch
Patch6016:     backport-jit-fail-early-in-ffcps_-if-subject-shorter-than-off.patch
Patch6017:     backport-jit-fix-pcre2_jit_free_unused_memory-if-sljit-not-us.patch
Patch6018:     backport-pcre2grep-document-better-possible-multiline-matchin.patch
Patch6019:     backport-no-partial-match-if-trailing-data-is-invalid-utf-238.patch
Patch6020:     backport-Fix-an-invalid-match-of-ascii-word-classes-when-inva.patch
Patch6021:     backport-fix-wrong-test.patch
Patch6022:     backport-fix-CVE-2022-41409.patch

BuildRequires:  autoconf libtool automake coreutils gcc make readline-devel
Obsoletes:      pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       bundled(sljit)

%description
PCRE2 is a re-working of the original PCRE1 library to provide an entirely new
API. Since its initial release in 2015, there has been further development of
the code and it now differs from PCRE1 in more than just the API.
PCRE2 is written in C, and it has its own API. There are three sets of
functions, one for the 8-bit library, which processes strings of bytes, one for
the 16-bit library, which processes strings of 16-bit values, and one for the
32-bit library, which processes strings of 32-bit values. Unlike PCRE1, there
are no C++ wrappers.

The distribution does contain a set of C wrapper functions for the 8-bit
library that are based on the POSIX regular expression API (see the pcre2posix
man page). These are built into a library called libpcre2-posix. Note that this
just provides a POSIX calling interface to PCRE2; the regular expressions
themselves still follow Perl syntax and semantics. The POSIX API is restricted,
and does not give full access to all of PCRE2's facilities.

%package devel
Summary:     Development files for %{name}
Requires:    %{name} = %{version}-%{release}
Obsoletes:   pcre2-static
Provides:    pcre2-static

%description devel
%{summary}.

%package help
Summary:    Man pages for %{name}
BuildArch:  noarch

%description help
%{summary}.

%prep
%autosetup -n %{name}-%{version} -p1

autoreconf -vif

%build
%configure \
%ifarch riscv64 sw_64 loongarch64
    --disable-jit \
%else
    --enable-jit \
%endif
    --enable-pcre2grep-jit \
    --disable-bsr-anycrlf \
    --disable-coverage \
    --disable-ebcdic \
    --disable-fuzz-support \
    --disable-jit-sealloc \
    --disable-never-backslash-C \
    --enable-newline-is-lf \
    --enable-pcre2-8 \
    --enable-pcre2-16 \
    --enable-pcre2-32 \
    --enable-pcre2grep-callout \
    --enable-pcre2grep-jit \
    --disable-pcre2grep-libbz2 \
    --disable-pcre2grep-libz \
    --disable-pcre2test-libedit \
    --enable-pcre2test-libreadline \
    --disable-rebuild-chartables \
    --enable-shared \
    --enable-static \
    --enable-unicode \
    --disable-valgrind \
    --disable-silent-rules

%make_build

%install
%make_install

#Unpacked files
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%check
make check

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%license %{_pkgdocdir}/{COPYING,LICENCE}
%doc AUTHORS ChangeLog NEWS HACKING README
%{_libdir}/libpcre2-8.so.*
%{_libdir}/libpcre2-posix.so.*
%{_libdir}/libpcre2-16.so.*
%{_libdir}/libpcre2-32.so.*
%{_bindir}/pcre2grep
%{_bindir}/pcre2test

%files devel
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*
%{_bindir}/pcre2-config
%doc ./src/pcre2demo.c

%files help
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_pkgdocdir}/*.txt
%{_pkgdocdir}/html/

%changelog
* Mon Jul 31 2023 yangmingtai <yangmingtai@huawei.com> - 10.39-9
- DESC:fix CVE-2022-41409

* Mon Jun 26 2023 yangmingtai <yangmingtai@huawei.com> - 10.39-8
- DESC:sync community patchs

* Thu Mar 16 2023 yangmingtai <yangmingtai@huawei.com> - 10.39-7
- DESC:sync community patchs

* Sat Nov 26 2022 huyubiao <huyubiao@huawei.com> - 10.39-6
- Update the Source0 URL.

* Mon Nov 14 2022 zhaozhen <zhaozhen@loongson.cn> - 10.39-5
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:fix build error for loongarch64

* Thu Nov 3 2022 wuzx<wuzx1226@qq.com> - 10.39-4
- Add sw64 architecture

* Tue Oct 18 2022 yangmingtai <yangmingtai@huawei.com> - 10.39-3
- DESC:sync community patchs

* Sat May 28 2022 yangmingtai <yangmingtai@huawei.com> - 10.39-2
- DESC:fix CVE-2022-1586 and CVE-2022-1587

* Wed Dec 1 2021 wangjie <wangjie375@huawei.com> - 10.39-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:Update pcre2 to 10.39

* Thu Jan 21 2021 yixiangzhike <zhangxingliang3@huawei.com> - 10.36-1
- Type:requirement
- ID:NA
- SUG:NA
- DESC:update to 10.36

* Fri Jul 24 2020 zhangxingliang <zhangxingliang3@huawei.com> - 10.35-1
- Type:update
- ID:NA
- SUG:NA
- DESC:update to 10.35

* Tue Jun 2 2020 whoisxxx <zhangxuzhou4@huawei.com> - 10.33-4
- DESC: Disable jit for RISC-V

* Tue Apr 7 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-3
- Type:cves
- ID:CVE-2019-20454
- SUG:NA
- DESC:fix CVE-2019-20454

* Mon Feb 3 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-2
- Fix stack buffer overflow

* Sat Sep 14 2019 openEuler Buildteam <buildteam@openeuler.org> - 10.33-1
- Package init
